<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.act.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	define ("IN-GEKKO", true);

	require_once "../../conf.php";

	LoadLib (
		"format.lib.php", "news"
	);
	
	require_once GEKKO_ROOT."lib/auth.inc.php";

	varImport("action", "id", "return");

	switch ($action) {
		case "create":
			if (is_admin() || gauth(conf::getkey("news", "auth_submit"))) {

				varImport("icon", "status", "category", "title", "introduction",
				"content", "allowcomments", "source");

				if (!is_admin()) {
					// antiflood
					$AccessTable->load_rule (
						$AccessTable->set_generic_rule("news-user-submit", "post"),
						"E_ANTI_FLOOD"
					);
				}

				requireVars("category", "title", "content");

				rtb_codefix($content);
				rtb_codefix($introduction);

				if (!$introduction)
					$introduction = mkIntro($content);

				// inserting into database
				$db->query ("
				INSERT INTO ".db_table("news")."
					(
						id,
						userid,
						category,
						icon,
						title,
						introduction,
						content,
						creationtime,
						pagereads,
						source,
						status,
						allowcomments
					)
						VALUES
					(
						'".$db->free_id("news")."',
						'{$USER["id"]}',
						'{$category}',
						'{$icon}',
						'{$title}',
						'{$introduction}',
						'{$content}',
						'".time()."',
						'0',
						'{$source}',
						'".(is_admin() ? $status : 2)."',
						'{$allowcomments}'
					)
				", __FILE__, __LINE__);

				slog(is_admin() ? "news: posted '$title'" : "news: submitted '$title' to revision", "actions", 1);

				if (!is_admin())
					$return = urlEvalPrototype("index.php/module=news?message=".urlencode(_l("L_SUBMISSION_THANKS"))."&type=success", true, false);

			} else {
				abort(accessDenied());
			}
		break;
	}

	if (is_admin()) {
		switch ($action) {
			case "delete":
				varRequire("id");

				execWithEach($id, "news::deleteItem");
			break;
			case "publish":
				varRequire("id");
	
				$db->query("SELECT status FROM ".db_table("news")."
				WHERE id = '{$id}' AND status = '0' OR status = '2' ", __FILE__, __LINE__);
				
				// updating time if this entry was a draft or if it was submitted by an user
				$upd_time = ($db->num_rows());
	
				$db->query("UPDATE ".db_table("news")." SET
				status = '1' ".($upd_time ? ", creationtime = '".time()."'" : "")."
				WHERE id = '{$id}'", __FILE__, __LINE__);
	
			break;
			case "edit":

				varImport("id", "icon", "status", "category", "title", "introduction", "content",
				"allowcomments", "source");

				varRequire("id", "category", "title", "content");

				rtb_codefix($content);
				rtb_codefix($introduction);

				if (!$introduction)
					$introduction = mkIntro($content);

				// if this entry was a draft we need to update creation time
				$ptime = false;
				$db->query("SELECT status FROM ".db_table("news")." WHERE id = '{$id}'");
				$row = $db->fetch_row();

				if (!$row["status"])
					$ptime = true;

				$db->query("
					UPDATE ".db_table("news")." SET
						category = '{$category}',
						icon = '{$icon}',
						title = '{$title}',
						introduction = '{$introduction}',
						content = '{$content}',
						status = '{$status}',
						".($ptime ? "creationtime = '".time()."',": "")."
						allowcomments = '{$allowcomments}'
					WHERE id = '{$id}'
				", __FILE__, __LINE__);

				slog("news: entry '$id' was updated", "actions", 1);

			break;
		}

	}
	
	redirect($return);

	db_exit();
?>