<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.inc.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	LoadLib (
		"categories", "comments", "users", "news", "feeder.lib.php"
	);

	Extract (
		URLGetArgs("null/action=alpha/type=string?id=int&page=page&date=date&category=string")
	);

	switch ($action) {
		case "submit":
			if (gauth(conf::getKey("news", "auth_submit"))) {

				$tpl = new ContentBlock();
				$tpl->insert("BLOCK_CONTENT", "news/news.form.tpl");

				$tpl->set_arr (
					Array (
						"BLOCK_TITLE"		=> _l("L_NEWS"),
						"BLOCK_SUBTITLE"	=> _l("L_COMPOSE"),
						"ICON"				=> "news.png",
						"ALLOWCOMMENTS"		=> true,
						"STATUS"			=> 2,
						"CATEGORY"			=> 0,
						"TITLE"				=> "",
						"INTRODUCTION"		=> "",
						"CONTENT"			=> "",
						"SOURCE"			=> "",
						"TITLE"				=> "",
						"ACTION"			=> "create",
						"RETURN"			=> ""
					)
				);

				$mcBuff = $tpl->make();
			} else {
				$mcBuff = accessDenied();
			}
		break;
		case "feed": {

			if (!$type)
				$type = $category;

			// removing extension
			$type = preg_replace("/\..*/", "", $type);

			$feed = new XMLFeed($type);

			if ($category) {
				$access = false;

				$db->query("SELECT id, auth_access FROM
				".db_table("category")." WHERE category = '{$category}'",
				__FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row($res);
					$cat_lock = "category = '{$row["id"]}'";
					// checking access for general public
					$access = gauth($row["auth_access"], "*");
				}
				if (!$access) {
					abort(accessDenied());
					break;
				}
			} else {
				$cat_lock = Categories::createLock("category", "*");
			}

			$db->query ("
			SELECT
					id, userid, title, introduction, creationtime, category
			FROM ".db_table("news")." WHERE status = '1' AND ($cat_lock)
			ORDER BY creationtime DESC LIMIT 30
			", __FILE__, __LINE__);

			if ($db->num_rows()) {
				while ($row = $db->fetch_row()) {

					Format::Style($row["introduction"], $row["userid"]);

					$row["content"] = $row["introduction"];

					$row["CATEGORY"] = cache_func("Categories::getCategory", $row["category"], true);
					$row["LINK"] = urlevalprototype("index.php/module=news/action=view/title=".title_encode($row["title"])."?id={$row["id"]}");
					$row["COMMENTS"] = urlevalprototype("index.php/module=news/action=view/title=".title_encode($row["title"])."?id={$row["id"]}");

					$feed->addItem($row);
				}

				abort($feed->serve($type));
			}

		}
		case "view": {
			if ($id) {
				$tpl = new ContentBlock();
				$tpl->load("news/view.tpl");

				// updating reads counter
				$db->query("UPDATE ".db_table("news")."
					SET pagereads = pagereads + 1 WHERE id = '{$id}'", __FILE__, __LINE__);

				if ($db->affected_rows()) {

					$db->query("
						SELECT
						id, userid, category, icon, title, content, creationtime, source, pagereads, allowcomments
						FROM ".db_table("news")." WHERE status = '1' AND id='{$id}'
					", __FILE__, __LINE__);

					$row = $db->fetch_row();

					if (categories::auth($row["category"])) {

						saneHTML($row, "content");

						Format::Style($row["content"], $row["userid"]);

						$tpl->set_arr($row);

						$mcBuff = $tpl->make();

						title_attach($row["title"], 1);

					} else {
						$mcBuff = accessDenied();
					}
				}
			}
			break;
		}
		default:

			$date_lock = (is_array($date = timeMark($date))) ? "creationtime >= '{$date[0]}' AND creationtime <= '{$date[1]}'": "1";

			if ($category && $id) {
				// category string
				$access = false;

				$db->query("SELECT id, category, auth_access FROM ".db_table("category")."
				WHERE id = '{$id}' AND ({$date_lock})", __FILE__, __LINE__);

				if ($db->num_rows()) {
					$row = $db->fetch_row();
					$cat_lock = "category = '{$row["id"]}'";
					$access = gauth($row["auth_access"]);
				}
				if (!$access) {
					$mcBuff = accessDenied();
					break;
				}
			} else {
				$cat_lock = "(category = '".implode("' OR category ='", Categories::fetchAllowed())."')";
			}

			$tpl = new ContentBlock();
			$tpl->load("news/index.tpl");

			$pager = $db->pager (
				"SELECT id FROM ".db_table("news")." WHERE status = '1' AND ($date_lock) AND ($cat_lock)",
				"index.php/module=news?".($category ? "&category=".title_encode($category)."":"")."&page=%p",
				$page, conf::getkey("news", "items_per_page")
			);

			$db->query ("
			SELECT
				id, userid, category, icon, title, introduction,
				creationtime, pagereads, allowcomments
			FROM ".db_table("news")." WHERE status = '1' AND ($date_lock) AND ($cat_lock)
			ORDER BY creationtime DESC ".$pager["sql"]."
			", __FILE__, __LINE__);

			if ($db->num_rows()) {
				while ($row = $db->fetch_row()) {
					saneHTML($row, "introduction");

					Format::Style($row["introduction"], $row["userid"]);

					$row["BLOCK_ICON"] = mkIcon($row["icon"], 16);
					$row["BLOCK_TITLE"]	= $row["title"];

					$tpl->set_arr ($row, "ENTRY");
					$tpl->saveBuff("ENTRY");
				}
				$tpl->set_arr (
					Array (
						"PAGER" => $pager["html"]
					)
				);

				$mcBuff = $tpl->make();

				// inserting some useful HTML tags in main template
				htdoc_attach("HEAD", '<link rel="alternate" type="application/rss+xml" title="'._l("C_SITE.TITLE").'" href="'.urlevalprototype("index.php/module=news/action=feed/type=rss.xml", true, false).'">');
				htdoc_attach("FOOTER", mkFeederButtons(urlevalprototype("index.php/module=news/action=feed/type=%s", true, false)));
			}
		break;

	}
?>