<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: main.lib.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class News {
		/**
		* deleteItem(item_id)
		*/
		function deleteItem($id) {
			LoadLib ("comments");

			// deleting comments
			Comments::deleteItems("news", $id);

			slog("news: deleted news entry '$id'", "actions", 1);

			return $GLOBALS["db"]->query ("DELETE FROM ".db_table("news")." WHERE id='{$id}'", __FILE__, __LINE__, true);
		}
		/**
		* itemSetStatus(item_id, status);
		*/
		function itemSetStatus($id, $status) {
			return $GLOBALS["db"]->query ("UPDATE ".db_table("news")." SET status = '{$status}' WHERE id='{$id}'", __FILE__, __LINE__, true);
		}

		/**
		* getPossibleStatus();
		* @returns: Possible status codes.
		*/
		function getPossibleStatus() {
			return Array(_l("L_DRAFT"), _l("L_PUBLISHED"), _l("L_WAITING"));
		}
		/**
		* prepareBlockForDisplay([sql_result_row]);
		* @returns: HTML formatted item to be displayed inside a block.
		*/
		function prepareBlockForDisplay(&$row) {
			saneHTML($row, "introduction");
			if (isset($row["introduction"])) {
				return '<h4><a href="'.urlevalprototype("index.php/module=news/action=view/title=".title_encode($row["title"])."?id={$row["id"]}").'">'
					.mkicon($row["icon"], 16).' '.$row["title"].'</a></h4>'
					.'<div class="small" style="text-align: right">'.dateformat($row["creationtime"]).'</div>'
					.mkintro($row["introduction"], 80)
					.'<div class="small" style="text-align:right"><b>'._l("L_POSTED_BY").'</b>: '.Users::mkUserLink($row["userid"]).'</div>';

			} else {
				return '<b><a title="'.dateformat($row["creationtime"]).'" href="'.urlevalprototype("index.php/module=news/action=view/title=".title_encode($row["title"])."?id={$row["id"]}").'">'
					.mkicon($row["icon"], 16).' '.$row["title"].'</a></b>'
					.'<div class="small" style="text-align:right"><b>'._l("L_POSTED_BY").'</b>: '.Users::mkUserLink($row["userid"]).'</div>';
			}
		}

		function allowComment($thread) {
			// Check Function Comments::allowComment();
			$db =& $GLOBALS["db"];
			$q = $db->query("SELECT id FROM ".db_table("news")."
			WHERE id = '{$thread}' AND allowcomments = '1' AND status = '1'",
			__FILE__, __LINE__, true);
			return $db->num_rows($q) ? true : false;
		}
	}
?>