<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2006, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sourceforge.net>
	*	@version	CVS: $Id: module.inc.php,v 1.1.1.1 2006/02/20 21:52:23 xiam Exp $
	*	@link		http://www.gekkoware.org
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	Class GekkoModule_News {
		function create_menu() {
			return false;
		}
		function configure() {
			Conf::getKey("news", "auth_submit", "*", "s");
			Conf::getKey("news", "items_per_page", 8, "i");
			Conf::getKey("news", "items_per_admin_page", 15, "i");
			Conf::getKey("news", "allow_user_comments", 1, "b");
		}
		function install() {
			$GLOBALS["db"]->query("
			CREATE TABLE ".db_table("news")." (
				id INT (11) UNSIGNED NOT NULL AUTO_INCREMENT, PRIMARY KEY (ID),
				userid MEDIUMINT (8) UNSIGNED NOT NULL,
				category SMALLINT (5) UNSIGNED NOT NULL,
				icon VARCHAR (64),
				title VARCHAR (128),
				introduction TEXT,
				content TEXT,
				creationtime INT (11) UNSIGNED NOT NULL,
				pagereads MEDIUMINT (8) UNSIGNED NOT NULL default 0,
				source VARCHAR (255),
				status TINYINT (1) UNSIGNED NOT NULL default 1,
				allowcomments ENUM('0','1') NOT NULL default '1'
			)
			",__FILE__, __LINE__, true);

			modCore::registerModule($GLOBALS["cgdb"]["news"], "news", "*", $GLOBALS["cgdb"]["news"]);

		}
		function uninstall() {
			$GLOBALS["db"]->query("DROP TABLE IF EXISTS ".db_table("news"),__FILE__, __LINE__, true);
		}
		function upgrade($provided_v) {
			if (Packages::checkVersion("0.5.8", $provided_v) < 0) {
				$GLOBALS["db"]->query("ALTER TABLE ".db_table("news")."
				CHANGE COLUMN reads pagereads MEDIUMINT (8) UNSIGNED NOT NULL default 0,
				CHANGE COLUMN allowcomments allowcomments ENUM('0','1') NOT NULL default '1'",
				__FILE__, __LINE__);
			}
		}
		function ext_uninstall($module) {

		}
	}

?>